# CSC 390, Lab 5

# Credit: based on the example here: http://scikit-learn.org/stable/modules/mixture.html#gmm


import numpy as np
import matplotlib as mpl
import matplotlib.pyplot as plt

from sklearn import datasets
from sklearn import mixture
from sklearn import decomposition


#---------
# GLOBALS
#---------


names = ['Setosa','Versicolour','Virginica']
colors = ['turquoise', 'navy', 'darkorange']
n_classes = len(colors)


#------
# MAIN
#------


# function to make ellipses
def make_ellipses(gmm, ax):
    for n in range(n_classes):
        if gmm.covariance_type == 'full':
            covariances = gmm.covariances_[n][:2, :2]
        elif gmm.covariance_type == 'tied':
            covariances = gmm.covariances_[:2, :2]
        elif gmm.covariance_type == 'diag':
            covariances = np.diag(gmm.covariances_[n][:2])
        elif gmm.covariance_type == 'spherical':
            print(gmm.covariances_[n])
            covariances = np.eye(gmm.means_.shape[1]) * gmm.covariances_[n]
        v, w = np.linalg.eigh(covariances)
        u = w[0] / np.linalg.norm(w[0])
        angle = np.arctan2(u[1], u[0])
        angle = 180 * angle / np.pi  # convert to degrees
        v = 2. * np.sqrt(2.) * np.sqrt(v)
        ell = mpl.patches.Ellipse(gmm.means_[n, :2], v[0], v[1],
                                  180 + angle, color=colors[n])
        ell.set_clip_box(ax.bbox)
        ell.set_alpha(0.5)
        ax.add_artist(ell)


# TODO 1: load iris dataset


# TODO 2: Gaussian mixture model


# TODO 3: print means and variances


# list comprehension for colors
color_lst = [colors[y_value] for y_value in y]

# create a scatter plot
plt.scatter(X[:,0], X[:,1], c=color_lst)
plt.xlabel('feature 1')
plt.ylabel('feature 2')
plt.title('GMM on Iris flower dataset')

# create legend
leg_objects = []
for i in range(3):
    circle, = plt.plot([], c=colors[i], marker='o')
    leg_objects.append(circle)
plt.legend(leg_objects,names)

# TODO 4: make ellipses
ax = plt.subplot(1,1,1)

# show the plot
plt.show()







    
